10000 REMark XREF - Cross ref SuperBASIC program
10010 REMark        Chas Dillon Dec 86, rev Jun 88, Feb 89, Nov 89
10020 :
10030 :
10040 REMark     Extra cmds/fns: ALLOCATION, BASIC_B%, BASIC_L, CURSOR_ON/OFF
10050 REMark                     PEEK_F, BASIC_NAME$, BASIC_POINTER, BASIC_TYPE%
10060 :
10070 REMark  ARBITRARY:  20K name occurrences in target program
10080 REMark              15 calls avg per proc/fn
10090 :
10100 TURBO_objfil 'win1_Chas_xref_bin310'
10110 TURBO_taskn  'XREF 3.10'
10120 TURBO_objdat 15
10130 TURBO_repfil
10140 TURBO_diags  'd' : TURBO_struct 's' : TURBO_model  '<'
10150 TURBO_optim  'b' : TURBO_windo   0  : TURBO_locstr 'ignore'
10160 :
10170 IMPLICITB  Assignment, assigned, binthere, cut_sheet, Data_Item
10180 IMPLICITB  Dialogue_Completed, debugging, defined, deleting
10190 IMPLICITB  End_of_Stmt, end_def, hash_was_last, Implicit_Directive
10200 IMPLICITB  Initialised, io_err, keep_assign, keep_hash, main_report
10210 IMPLICITB  moaner, Next_is_Equals, names_shown, Open_Brkt, opening
10220 IMPLICITB  Proc_in_Trace, pending, printing_ROMs, proctrace, quit
10230 IMPLICITB  Routine_in_Call_Paths, referred, resolve, rtn_is_func
10240 IMPLICITB  Scan_Ended, Scoping_Problem, Symbol_is_Assign, scoping_procs
10250 IMPLICITB  scanning, silent, test_flag, User_Defined, valid, valued
10260 IMPLICITB  wanted
10270 :
10280 IMPLICITF  init_occ, Manifest_Value, min_occ, min_occs, numval, occ
10290 IMPLICITF  arbit_occ
10300 :
10310 IMPLICIT%  act_names, add_size, array
10320 IMPLICIT%  base, brkct, brkt, btm, bt, Colm, called_scope, called, caller
10330 IMPLICIT%  child_size, chn, col, curproc, data_type
10340 IMPLICIT%  extrnl_pos, flag
10350 IMPLICIT%  fst_wd, fwd, Head_Ptr, hits, hi
10360 IMPLICIT%  Item_Class, ic, idx, ii, impboo_pos, impchr_pos
10370 IMPLICIT%  impdbl_pos, impflt_pos, impint_pos, implng_pos
10380 IMPLICIT%  impstr_pos, impvod_pos, input_pos, instance, inst_ct, jj
10390 IMPLICIT%  keep_brkct, keep_param, keep_stmt, keep_valu, kk, level, lev
10400 IMPLICIT%  line_ct, line_match, line_num, line_ptr, lins, listlim, lp
10410 IMPLICIT%  look_at, lo, lpp, Max_Int, Min_Int, manfst_pos
10420 IMPLICIT%  mask_val, mask_word, max_level, max_names, max_procs
10430 IMPLICIT%  max_width, me_here, name_id
10440 IMPLICIT%  nt_indx, page, param_no, parent, prior
10450 IMPLICIT%  ref_ptr, ref_chain, ref_ids, ref_list, refnce_pos, proc_id
10460 IMPLICIT%  read_pos, Size_Factor, scan_line
10470 IMPLICIT%  scope, sec_wd, stmt_type, symval
10480 IMPLICIT%  thd_wd, token, top, tot_hits, trace_child_sz, trace_ct
10490 IMPLICIT%  trace_proc_max, trace_proc_min
10500 IMPLICIT%  valu, win_widf, xx
10510 IMPLICIT%  yy
10520 :
10530 IMPLICITL  a, Buffer_Addr, bffr_base, bffr_last, bffr_lim, bffr
10540 IMPLICITL  buffer, computed_local, computed_size, cum_local
10550 IMPLICITL  Decoded_Size, data_size, factor, Inst_Addr, keep_ptr
10560 IMPLICITL  localsp, local_data, local_recur, lval, Mast_Addr
10570 IMPLICITL  max_local_data, mem, occurs, offset, ptr1, ptr, reqd
10580 IMPLICITL  src, Trace_Next, target, trace_base, trace_ch_base
10590 IMPLICITL  trace_last, trace_lim, wk, x, y
10600 :
10610 REMark Grab space from system, set up Master entry per name in NAME TABLE
10620 REMark Scan program, noting instances of user defined names
10630 REMark - one Detail entry per occurrence - and noting any/all
10640 REMark ROM names that are actually used
10650 :
10660 REMark For each user defined item in NAME TABLE
10670 REMark    print name and type (array, int, string, proc, func)
10680 REMark      print the line nos on which it appears
10690 REMark      for a data item, against the line no
10700 REMark        print 'L' if in a LOCal or variable on a DEFine
10710 REMark        print 'd' if in a DIM
10720 REMark        print 'a' if assigned a value (LET, FOR, READ, INPUT)
10730 REMark        print 'A' if assigned a value (via REFERENCE)
10740 REMark        print 'r' if REPeat loop id
10750 REMark        print 'f' if FOR loop id
10760 REMark        print 'R' if used on a Reference line
10770 REMark      for a proc/fn, against the line no
10780 REMark        print 'd' if the defproc/deffn
10790 REMark      for all names, print a summary showing
10800 REMark        data items never (apparently) 'assigned'
10810 REMark        items defined/assigned but not used
10820 REMark For each ROM name used - list the name and times name is used
10830 :
10840 REMark Table structures
10850 :
10860 REMark     Master entry (one per name)                     Mast_Addr
10870 REMark       All master entries occur at beginning of the table
10880 REMark         Head pointer            word  (ROM rtn: -ve count)
10890 REMark         Name Table index        word
10900 REMark         Name class              byte  data = 0, routine = 1
10910 REMark         Basic Type              byte  1,2,4 : str, float, int
10920 REMark         Ref. params flag        word  bit set on if ith param ref
10930 REMark         Data size               long  size of data or local
10940 REMark     - during processing the Head pointer points to the latest
10950 REMark       child of this master (0 if none) - i.e. points to the end
10960 REMark       of the list for this name
10970 REMark     - after prog scan complete pointers are inverted - see below
10980 :
10990 REMark     Detail entry (one per occurrence of name)       Inst_Addr
11000 REMark       Child entries occur in any order
11010 REMark         Line number             word
11020 REMark         List pointer            word
11030 REMark         Occurrence type         word
11040 REMark      - during processing, the List pointer is 'prior' and points
11050 REMark        to the slot in the table in which the previous occurrence
11060 REMark        is stored (0 if none)
11070 REMark      - after processing, Mast_Addr and Inst_Addr pointers are
11080 REMark        adjusted so that all are 'next' - the Mast_Addr (Head)
11090 REMark        pointer points to the 1st child, which points to the second
11100 REMark        child etc, with the last child having a 'next' pointer of 0.
11110 :
11120 REMark     Trace master (one per proc/fn name)
11130 REMark         Called list pointer (last)       word
11140 REMark         Highest level of caller          byte
11150 REMark         Lowest  level of caller          byte
11160 REMark         Recursive flag                   byte
11170 REMark         Scope level                      byte
11180 REMark         Tag of scoping routine           word
11190 REMark         Tag of highest calling proc/fn   word
11200 REMark         Tag of lowest  calling proc/fn   word
11210 REMark         Local dataspace for routine      word
11220 REMark         Calling list pointer (last)      word
11230 REMark     Trace entry (one per occurrence of proc/fn call)
11240 REMark         List pointer (prior)             word
11250 REMark         Tag of called proc/fn            word
11260 :
11270 WHEN ERRor
11280   IF deleting OR opening : io_err = 1 : RETRY
11290   PAPER 4 : INK 0 : AT 0,0
11300   PRINT "  Fatal error type: ";ERNUM%;" at ";ERLIN%
11310   INPUT "  Press ENTER to terminate: ";q$
11320   STOP
11330   END WHEN
11340 :
11350 IF Initialised : Do_Xref
11360 INPUT \\"End of task - Press ENTER: ";q$
11370 STOP
11380 :
11390 DEFine FuNction Initialised
11400 DIM q$(36),tof$(2),cr$(2),vers$(6),pnam$(36)
11410 :
11420   IF COMPILED : OPEN #1,'con'
11430   win_widf = 74-3
11440   vers$ = "3.10"
11450 :
11460   Set_Constants
11470 :
11480   REMark ____ Figurative Constants for the prog  ____
11490   MANIFEST : assign_val = 1  : REMark 'a'
11500   MANIFEST : forvar_val = 2  : REMark 'f'
11510   MANIFEST : repvar_val = 3  : REMark 'r'
11520   MANIFEST : dimdef_val = 4  : REMark 'd'
11530   MANIFEST : locdef_val = 5  : REMark 'L'
11540   MANIFEST : dimuse_val = 6  : REMark ' ' (loc and dim array dims as var)
11550   MANIFEST : defdef_val = 7  : REMark 'd'
11560   MANIFEST : defuse_val = 8  : REMark 'L'
11570   MANIFEST : refnce_val = 9  : REMark 'R'
11580   MANIFEST : refass_val =10  : REMark 'A'
11590   MANIFEST : avg_str_len     = 30        : REMark Average string param or fn
11600              arbit_occ       = 20 * 1024 : REMark 20K name occurrences
11610   MANIFEST : arbit_calls     = 15        : REMark 15 calls per proc/fn
11620   MANIFEST : min_occ         = 2         : REMark Min instances per name
11630   MANIFEST : min_calls       = 2         : REMark Min calls per proc/fn
11640   MANIFEST : call_size       = 6         : REMark Stack space reqd for call
11650   MANIFEST : class_usr_array = 3
11660   MANIFEST : class_usr_proc  = 4
11670   MANIFEST : class_usr_fn    = 5
11680   MANIFEST : class_ROM_proc  = 8
11690   MANIFEST : class_ROM_fn    = 9
11700   MANIFEST : type_str        = 1
11710   MANIFEST : type_flt        = 10
11720   MANIFEST : type_int        = 4
11730   MANIFEST : type_boo        = 5
11740   MANIFEST : type_dbl        = 3
11750   MANIFEST : type_chr        = 7
11760   MANIFEST : type_lng        = 6
11770   MANIFEST : type_man        = 8
11780   MANIFEST : type_void       = 9
11790 :
11800   REMark Offsets into Name table
11810   MANIFEST : mst_list        = 0  : REMark Head pointer (to last)           word
11820   MANIFEST : mst_nti         = 2  : REMark Name Table index                 word
11830   MANIFEST : mst_procfn      = 4  : REMark Flag 1=name is proc or fn        byte
11840   MANIFEST : mst_btyp        = 5  : REMark Basic Type                       byte
11850   MANIFEST : mst_refparm     = 6  : REMark Ref params flag                  byte
11860   MANIFEST : mst_datasz      = 8  : REMark Amount of local dataspace reqd   long
11870   MANIFEST : mst_child       = 12 : REMark Called list pointer (to last)    word
11880   MANIFEST : mst_hilev       = 14 : REMark Highest level of caller          byte
11890   MANIFEST : mst_lolev       = 15 : REMark Lowest  level of caller          byte
11900   MANIFEST : mst_recur       = 16 : REMark Recursive flag                   byte
11910   MANIFEST : mst_scoplev     = 17 : REMark Scope level                      byte
11920   MANIFEST : mst_scoptag     = 18 : REMark Tag of scoping routine           word
11930   MANIFEST : mst_hitag       = 20 : REMark Tag of highest calling proc/fn   word
11940   MANIFEST : mst_lotag       = 22 : REMark Tag of lowest  calling proc/fn   word
11950   MANIFEST : mst_parent      = 24 : REMark Calling list pointer (to last)   word
11960 :
11970   MANIFEST : master_size     = 12 : child_size     = 6
11980   MANIFEST : trace_mast_sz   = 14 : trace_child_sz = 4
11990   MANIFEST : stepper         = 7  : REMark width of line_num on report
12000   MANIFEST : scan_line       = 13 : REMark position on screen
12010   MANIFEST : max_refids      = 60 : REMark max items using BY REF parms
12020   MANIFEST : max_reflist     = 16 : REMark max items in 1 REFERENCE list
12030 :
12040 DIM ref_ids(max_refids)   : REMark List of proc/fns using BY REF parameters
12050 DIM ref_list(max_reflist) : REMark Latest REFERENCE list of var. names
12060   max_width = 80       : REMark width of report line
12070   ref_ptr = 0 : ref_chain = 0
12080   io_err = 0 : opening = 0 : deleting = 0 : scanning = 0
12090   chn = 1 : page = 0  : line_ct = 0
12100   input_pos  = -99     : read_pos   = -99     : extrnl_pos = -99
12110   impint_pos = -99     : impstr_pos = -99     : implng_pos = -99
12120   impboo_pos = -99     : impflt_pos = -99     : impdbl_pos = -99
12130   impchr_pos = -99     : manfst_pos = -99     : refnce_pos = -99
12140   impvod_pos = -99
12150   Announce
12160   RETurn Dialogue_Completed
12170   END DEFine
12180 :
12190 DEFine PROCedure Set_Constants
12200 REMark >>>--<<<   -----------------------------------------------------
12210   REMark ____ Sinclair equates (from QDOS manual)    ____
12220   MANIFEST : bv_pfbas=16 : REMark Source start pointer offset
12230   MANIFEST : bv_pfp  =20 : REMark Source end pointer offset
12240   MANIFEST : bv_ntbas=24 : REMark Name table pointer offset
12250   MANIFEST : bv_ntp  =28 : REMark Name table end pointer
12260   MANIFEST : nt_entry=8
12270 :
12280   REMark ____ QL internal source representation codes  ____
12290   REMark tokens
12300   MANIFEST : tok_separator=142
12310   MANIFEST : tok_space=128 : tok_keyword=129 : tok_symbol=132 : tok_name = 136
12320   MANIFEST : tok_strng=139 : tok_text=140 : tok_lineno=141 : tok_end_of_prog=200
12330   MANIFEST : tok_nomin=240 : tok_nomax=255 : REMark Numbers use tokens 240-255
12340   REMark Symbols
12350   MANIFEST : sym_assign=1 : sym_colon=2 : sym_hash = 3 : sym_comma = 4
12360   MANIFEST : sym_opbrkt=5 : sym_clbrkt=6 : sym_eol=10
12370   REMark Keywords
12380   MANIFEST : key_end=1 : key_for = 2 : key_repeat=4
12390   MANIFEST : key_define=7 : key_then = 28
12400   MANIFEST : key_dim=25 : key_local=26 : key_let=27 : key_mistake = 31
12410   MANIFEST : key_impint = 104
12420   MANIFEST : key_impstr = 101
12430   MANIFEST : key_impdbl = 105
12440   MANIFEST : key_impflt = 106
12450   MANIFEST : key_implng = 107
12460   MANIFEST : key_impboo = 108
12470   MANIFEST : key_impchr = 109
12480   MANIFEST : key_impvod = 112
12490   MANIFEST : key_manfst = 110
12500   MANIFEST : key_refnce = 111
12510   MANIFEST : read_or_input = 222
12520 REMark >>>++<<<   -----------------------------------------------------
12530   END DEFine
12540 :
12550 DEFine PROCedure Announce
12560   MODE 0 : WINDOW 512,256,0,0 : PAPER 0 : CLS
12570   PAPER 2 : INK 0
12580   WINDOW 176,120,160,75 : CLS : PRINT
12590   CSIZE 3,1 : PRINT "  PDQ XREF"
12600   CSIZE 0,0 : PRINT \" SuperBASIC Cross Reference "\TO 8;"version ";vers$
12610   PRINT \"   Chas Dillon  1986/9"\\\" Press any key to continue ";
12620   CURSOR_ON #1! : q$ = INKEY$(#1,-1) : CURSOR_OFF
12630   WINDOW 480,230,24,16 : PAPER 0 : CLS
12640   END DEFine
12650 :
12660 DEFine FuNction Dialogue_Completed
12670 LOCal reqd, mem, ii, jj, lp
12680   PAPER 2 : INK 0
12690   PRINT " PDQ XREF v";vers$;" - SuperBASIC Cross Reference ";TO 60;"Chas Dillon, '86/9 "; : CLS 4
12700   PAPER 0 : PRINT \\\
12710   Prompt 15,"Title/name of program: " : pnam$ = q$
12720   Prompt 3,"Output to screen or printer (s/p): "
12730   cut_sheet = 0
12740   IF q$ == "p"
12750     Prompt 6,"Serial 1/2 or parallel (1/2/p): "
12760     IF q$ == "p"
12770       REPeat lp
12780         AT 6,0
12790         Prompt 19,"Enter device name: "
12800         IF NOT (q$(1 TO 3) == 'par' OR q$(1 TO 3)=='ser')
12810           deleting = 1
12820  RETRY_HERE
12830           IF io_err
12840             Prompt 1,"Output device unready or read-only; Press ENTER: "
12850             io_err = 0 : deleting = 0
12860             NEXT lp : END IF
12870           DELETE q$ : deleting = 0
12880           END IF
12890         opening = 1
12900 RETRY_HERE
12910         IF io_err
12920             Prompt 1,"Output device unready or read-only; Press ENTER: "
12930             io_err = 0 : opening = 0
12940             NEXT lp : END IF
12950         OPEN_NEW #3,q$ : chn = 3 : opening = 0 : CLS 2 : EXIT lp
12960         END REPeat lp
12970       ELSE
12980       IF q$ <> "2" : q$ = "1"
12990       OPEN #3,"ser"&q$&"hz" : chn = 3
13000       END IF
13010     Prompt 10,'Pause at page change (n/y): '
13020     cut_sheet = (q$=='y')
13030     Prompt 12,'Lines per page (dflt=66): '
13040     lpp = '0' & q$ : IF lpp <= 0 : lpp = 66
13050     Prompt 13,'Cols per line (dflt='&max_width&'): '
13060     max_width = '0' & q$ : IF max_width = 0 : max_width = 80
13070     END IF
13080   scoping_procs = 0
13090   max_width = max_width - stepper
13100   Prompt 0,'Full report or exceptions only (f/e): '
13110   test_flag = 0
13120   IF LEN(q$) > 1 : test_flag = (q$(1) == 't') : q$ = q$(2 TO)
13130   IF q$ == 'e'
13140     silent = 1 : proctrace = 0
13150     ELSE
13160     silent = 0
13170     Prompt 15,'Procedure Trace (n/y): '
13180     proctrace = (q$ == "y")
13190     debugging = (q$ = 'D') - (q$ = 'Z')
13200     IF debugging : proctrace = 1
13210     END IF
13220   IF chn <> 1
13230     tof$ = CHR$(12) : cr$ = CHR$(13)
13240     ELSE
13250     tof$ = "" : cr$ = "" : lpp = 66
13260     PRINT \"Control subsequent output using the CTRL/F5 combination"
13270     END IF
13280 :
13290   src = BASIC_POINTER((bv_pfbas))+2
13300   IF NOT (src < BASIC_POINTER((bv_pfp)))
13310     PRINT \\"No program found in SuperBASIC area" : RETurn 0
13320     END IF
13330   max_names = (BASIC_L((bv_ntp))-BASIC_L((bv_ntbas)))/nt_entry
13340   max_procs = 0 : trace_proc_min = 0 : trace_proc_max = 0
13350   FOR ii = 0 TO max_names-1
13360     ic = Item_Class(ii)
13370     IF ic = class_usr_proc OR ic = class_usr_fn
13380       max_procs = max_procs + 1
13390       IF trace_proc_min = 0 : trace_proc_min = ii
13400       trace_proc_max = ii
13410       END IF
13420     END FOR ii
13430 :
13440   reqd = proctrace * max_procs * trace_mast_sz
13450   reqd = reqd + max_names * (master_size+4)
13460 :
13470   bffr = Buffer_Addr(reqd, mem, arbit_occ/max_names, min_occ, child_size^1*max_names)
13480   IF bffr = 0 : RETurn 0
13490   bffr_lim  = bffr + mem
13500   trace_base = 0 : trace_last = 0
13510   IF proctrace
13520     trace_base = Buffer_Addr(0, mem, arbit_calls, min_calls, trace_child_sz^1*max_procs)
13530     IF trace_base <> 0
13540       trace_lim = trace_base + mem
13550       scoping_procs = 1
13560       END IF : END IF
13570 :
13580   Create_Hddrs
13590   IF act_names = 0 : PRINT "No variables found" : RETurn 0
13600   RETurn 1
13610   END DEFine
13620 :
13630 REFERENCE mem
13640 DEFine FuNction Buffer_Addr(reqd, mem, init_occ, min_occs, factor)
13650 LOCal occ, buffer, lp
13660   occ = init_occ
13670   REPeat lp
13680     mem = reqd + occ * factor
13690     buffer = ALLOCATION((mem))
13700     IF buffer > 0 : EXIT lp
13710     IF occ < min_occs : PRINT \\"Not enough memory" : RETurn 0
13720     occ = occ - .25
13730     END REPeat lp
13740   RETurn buffer
13750   END DEFine
13760 :
13770 DEFine PROCedure Create_Hddrs
13780 LOCal ii, ic, ptr
13790   AT scan_line,10 : PRINT 'Scanning names';
13800   act_names = 0 : bffr_base = bffr + 4 * max_names
13810   FOR ii = 0 TO max_names-1
13820     POKE_L bffr + 4 * ii, bffr_base
13830     IF User_Defined((ii))
13840       act_names = act_names + 1
13850       ELSE
13860       q$ = BASIC_NAME$((ii))
13870       IF q$ = "INPUT"     : input_pos  = ii
13880       IF q$ = "READ"      : read_pos   = ii
13890       IF q$ = "EXTERNAL"  : extrnl_pos = ii
13900       IF q$ = "MANIFEST"  : manfst_pos = ii
13910       IF q$ = "REFERENCE" : refnce_pos = ii
13920       IF q$ = "IMPLICIT%" : impint_pos = ii
13930       IF q$ = "IMPLICIT$" : impstr_pos = ii
13940       IF q$ = "IMPLICITL" : implng_pos = ii
13950       IF q$ = "IMPLICITB" : impboo_pos = ii
13960       IF q$ = "IMPLICITF" : impflt_pos = ii
13970       IF q$ = "IMPLICITD" : impdbl_pos = ii
13980       IF q$ = "IMPLICITC" : impchr_pos = ii
13990       IF q$ = "IMPLICITV" : impvod_pos = ii
14000       END IF
14010     ptr = Mast_Addr((ii))
14020     POKE_W ptr+mst_list,0            : REMark Head pointer
14030     POKE_W ptr+mst_nti,ii            : REMark Name table index
14040     POKE_W ptr+mst_procfn,BASIC_TYPE%((ii)) : REMark Proc flag, basic type
14050     POKE_W ptr+mst_refparm,0         : REMark Reference params flags
14060     POKE_L ptr+mst_datasz, 0         : REMark data size array/local
14070     bffr_base = bffr_base + master_size
14080     IF scoping_procs
14090       ic = Item_Class(ii)
14100       IF ic = class_usr_proc OR ic = class_usr_fn
14110         POKE   ptr+mst_procfn,  1   : REMark Set 'user routine' flag
14120         POKE_W ptr+mst_child,   0   : REMark Pointer to called list
14130         POKE_W ptr+mst_parent,  0   : REMark Pointer to calling list
14140         POKE_W ptr+mst_hilev, 255   : REMark High level, low level
14150         POKE_W ptr+mst_recur,   1   : REMark Recursion flag, scope level
14160         POKE_W ptr+mst_scoptag,-1   : REMark Scoping caller
14170         POKE_L ptr+mst_hitag,   0   : REMark Highest caller, lowest caller
14180         bffr_base = bffr_base + trace_mast_sz
14190         END IF : END IF
14200     END FOR ii
14210   bffr_last = bffr_base + child_size
14220   IF scoping_procs
14230     trace_last = trace_base + trace_child_sz
14240     trace_ch_base = trace_base : END IF
14250   END DEFine
14260 :
14270 DEFine PROCedure Do_Xref
14280   data_size = 0         : max_local_data = 0
14290   computed_size = 0     : computed_local = 0
14300   quit = 0 : local_recur = 0
14310   Scan_Prog
14320 :
14330   IF chn = 1 : CLS
14340   Check_Page 0
14350   AT scan_line+2,0 : Show_Stats (chn)
14360   IF chn <> 1 : Show_Stats 1
14370   Sort_Names (max_names)
14380 :
14390   IF quit
14400     PRINT #chn,\\"       INSUFFICIENT MEMORY SPACE - STOPPED AT LINE: ";line_num\\;cr$
14410     line_ct = line_ct - 5
14420     END IF
14430   PRINT #chn,\"P = PROCedure,   F = FuNction,   A = Array,   ' ' = Scalar variable";cr$
14440   PRINT #chn,"  I = Integer var/FN,   S = String var/FN,   F = Float  var/FN ";cr$
14450   PRINT #chn,"  B = Boolean var/FN,   L = Long   var/FN,   D = Double var/FN";cr$
14460   PRINT #chn,"  C = Char    var/FN,   M = Manifest const. ' '= Untyped (float/PROC)";cr$\\
14470 :
14480   main_report = 1 : Check_Page 9
14490   PRINT #chn,"User defined items: ";
14500   PRINT #chn,TO 29;"a = Assignment  d = DIM/DEFine  L = LOCal/DEFine";cr$
14510   PRINT #chn,TO 29;"f = FOR identifier  r = REPeat identifier";cr$
14520   PRINT #chn,TO 29;"A = pseudo assign   R = REFERENCE usage"\\;cr$
14530   Print_Panel 0
14540 :
14550   Check_Page 7
14560   IF NOT silent : PRINT #chn,\\\"System and extension Commands/Functions used:"\\;cr$
14570   Print_Panel 1
14580   IF NOT (names_shown OR silent) : PRINT #chn, "    NONE";cr$
14590   names_shown = 0 : silent = 0 : main_report = 0
14600   Check_Page 8
14610   PRINT #chn,\\\"The following names MAY reflect problems -"\;cr$
14620   PRINT #chn,"   e.g. Items defined but not (apparently) used ...";cr$
14630   PRINT #chn,"        Items used but not (apparently) assigned/defined ...";\\cr$
14640   Print_Panel 0
14650   IF NOT names_shown : PRINT #chn, "    NONE";cr$
14660   Check_Page 8
14670   PRINT #chn,\\"Data space requirements:";cr$
14680   PRINT #chn,,"User defined variables/arrays: ";(INT((511+data_size)/512)/2);'k';
14690   IF computed_size : PRINT #chn;'  (plus dynamic sized arrays)';cr$ : ELSE : PRINT #chn;cr$
14700   PRINT #chn,,"             Local data space: ";(INT((511+max_local_data)/512)/2);'k';
14710   IF computed_local : PRINT #chn;'  (plus dynamic sized arrays)';cr$ : ELSE : PRINT #chn;cr$
14720   IF local_recur : PRINT #chn,,"  Add allowance for recursion: ";local_recur;"b per instance";cr$
14730   PRINT #chn,"Add about 2k for system space (stacks etc)";cr$
14740   IF chn <> 1 : CLOSE #chn
14750   DEALLOCATE (bffr)
14760   IF scoping_procs : DEALLOCATE (trace_base)
14770   END DEFine
14780 :
14790 DEFine PROCedure Scan_Prog
14800   Clear_Stmt
14810   IF proctrace
14820     Check_Page 0
14830     PRINT #chn,\"Procedure name trace"\\\
14840     line_ct = line_ct - 3 : END IF
14850   local_data = 0 : inst_ct = 0
14860   curproc = 0 : trace_ct = 0
14870   AT scan_line,10 : PRINT "Scanning line: ";
14880   src = BASIC_POINTER((bv_pfbas))+2
14890   REPeat pass_lp
14900     REPeat hunt
14910       Getsym
14920       IF Scan_Ended : EXIT pass_lp
14930       IF token = tok_name : EXIT hunt
14940       Check_End_ProcFn
14950       END REPeat hunt
14960     IF line_num <= 0 : NEXT pass_lp
14970     name_id = valu
14980     fst_wd = line_num
14990     sec_wd = Head_Ptr((name_id))
15000     thd_wd = 0
15010     IF sec_wd < 0 : Chk_Read : NEXT pass_lp : REMark skip rom rtns
15020     IF sec_wd = 0
15030                                     REMark 1st time seen 'name'
15040       IF NOT User_Defined((name_id)) : Chk_Read : NEXT pass_lp
15050       END IF
15060     IF Data_Item(name_id) : Analyse_Variable : ELSE : Analyse_ProcFn
15070     Store_Instance
15080     IF quit : EXIT pass_lp
15090     END REPeat pass_lp
15100   Check_End_ProcFn
15110   IF ref_chain<>0 : Modify_By_Ref_Params
15120   line_ct = 0
15130   IF scoping_procs : Show_ProcTrace
15140   END DEFine
15150 :
15160 DEFine FuNction Scan_Ended
15170   IF token=tok_end_of_prog : RETurn 1
15180   IF test_flag : IF line_num >= 10000 : RETurn 1
15190   RETurn 0
15200   END DEFine
15210 :
15220 DEFine PROCedure Analyse_Variable
15230 LOCal ii
15240   IF Assignment
15250     thd_wd = assign_val
15260     IF stmt_type = key_for : thd_wd = forvar_val
15270     IF stmt_type = key_manfst
15280       POKE_L Mast_Addr(name_id)+mst_datasz, Manifest_Value
15290       POKE   Mast_Addr(name_id)+mst_btyp, type_man
15300       END IF
15310     RETurn : END IF
15320   SELect ON stmt_type
15330     = key_dim    : IF NOT brkct
15340                      thd_wd = dimdef_val
15350                      wk = Decoded_Size(name_id)
15360                      IF wk > PEEK_L(Mast_Addr(name_id)+mst_datasz)
15370                        POKE_L(Mast_Addr(name_id)+mst_datasz), wk : END IF
15380                      ELSE
15390                      IF PEEK(Mast_Addr(name_id)+mst_btyp) <> type_man
15400                        computed_size = 1 : END IF
15410                      END IF
15420     = key_local  : IF NOT brkct
15430                      thd_wd = locdef_val
15440                      local_data = local_data + Decoded_Size(name_id)
15450                      ELSE
15460                      IF PEEK(Mast_Addr(name_id)+mst_btyp) <> type_man
15470                        computed_size = 1 : END IF
15480                      END IF
15490     = key_define : thd_wd = defuse_val
15500                    wk = Size_Factor(name_id)
15510                    IF wk = 1 : wk = avg_str_len
15520                    local_data = local_data + wk
15530                    FOR ii=1 TO ref_ptr
15540                      IF name_id = ref_list(ii)
15550                        mask_val = 2^param_no
15560                        a = Mast_Addr(proc_id)+mst_refparm
15570                        POKE_W a, PEEK_W(a) || mask_val
15580                        thd_wd = refnce_val : EXIT ii
15590                        END IF : END FOR ii
15600                    param_no = param_no + 1
15610     = key_repeat : thd_wd = repvar_val
15620     = key_refnce : ref_ptr = ref_ptr + 1
15630                    IF ref_ptr <= max_reflist : ref_list(ref_ptr) = name_id
15640     = REMAINDER  : Set_Implicit_Types
15650     END SELect
15660   END DEFine
15670 :
15680 DEFine FuNction Manifest_Value
15690   REMark Try for (simple) Manifest value, in case it is used for DIM sizing
15700   Look_Ahead
15710   IF NOT Symbol_is_Assign : BackTrack : RETurn -1
15720   numval = 0
15730   Getsym
15740   IF numval = 0 : BackTrack : RETurn -1
15750   Getsym
15760   IF NOT End_of_Stmt : BackTrack : RETurn -1
15770   BackTrack
15780   RETurn numval
15790   END DEFine
15800 :
15810 DEFine PROCedure Set_Implicit_Types
15820   SELect ON stmt_type
15830     = key_impint : POKE Mast_Addr(name_id)+mst_btyp, type_int
15840     = key_impstr : POKE Mast_Addr(name_id)+mst_btyp, type_str
15850     = key_implng : POKE Mast_Addr(name_id)+mst_btyp, type_lng
15860     = key_impboo : POKE Mast_Addr(name_id)+mst_btyp, type_boo
15870     = key_impchr : POKE Mast_Addr(name_id)+mst_btyp, type_chr
15880     = key_impflt : POKE Mast_Addr(name_id)+mst_btyp, type_flt
15890     = key_impdbl : POKE Mast_Addr(name_id)+mst_btyp, type_dbl
15900     = key_impvod : POKE Mast_Addr(name_id)+mst_btyp, type_void
15910     END SELect
15920   END DEFine
15930 :
15940 DEFine PROCedure Analyse_ProcFn
15950 LOCal ii
15960   Set_Implicit_Types
15970   proc_id = name_id
15980   IF stmt_type = key_define OR stmt_type = key_dim
15990     thd_wd = defdef_val : REMark EXTERNAL & DEFine
16000     IF ref_ptr <> 0
16010       ref_chain = ref_chain+1
16020       IF ref_chain <= max_refids : ref_ids(ref_chain) = proc_id
16030       END IF
16040     END IF
16050   IF proctrace
16060     IF NOT Implicit_Directive
16070       Store_Trace_Instance
16080       IF quit : scoping_procs= 0 : quit = 0
16090       END IF : END IF
16100   IF scoping_procs
16110     IF stmt_type = key_define
16120       curproc = name_id
16130       IF Item_Class(name_id) = class_usr_fn
16140         ii = PEEK(Mast_Addr(name_id)+mst_btyp)
16150         SELect ON ii
16160           = type_str   : local_data = avg_str_len
16170           = type_int   : local_data = 2
16180           = REMAINDER  : local_data = 6
16190           END SELect
16200         END IF : END IF : END IF
16210   END DEFine
16220 :
16230 DEFine FuNction Implicit_Directive
16240   SELect ON stmt_type
16250     = key_impint, key_impstr, key_impvod : RETurn 1
16260     = key_impboo, key_impdbl, key_impflt, key_implng, key_impchr
16270                                  RETurn 1
16280     END SELect
16290   RETurn 0
16300   END DEFine
16310 :
16320 DEFine PROCedure Check_End_ProcFn
16330   IF NOT end_def : RETurn
16340   IF local_data > max_local_data
16350     max_local_data = local_data  : END IF
16360   IF scoping_procs
16370     IF curproc <> 0 AND local_data <> 0
16380       POKE_L Mast_Addr(curproc)+mst_datasz, local_data : END IF
16390     curproc = 0 : END IF
16400   local_data = 0 : ref_ptr = 0
16410   END DEFine
16420 :

16430 DEFine PROCedure Chk_Read
16440 LOCal ii
16450   ii = name_id
16460   SELect ON ii
16470     = read_pos, input_pos : stmt_type = read_or_input
16480     = extrnl_pos          : stmt_type = key_dim
16490     = manfst_pos          : stmt_type = key_manfst
16500     = impint_pos          : stmt_type = key_impint
16510     = impstr_pos          : stmt_type = key_impstr
16520     = impdbl_pos          : stmt_type = key_impdbl
16530     = impflt_pos          : stmt_type = key_impflt
16540     = implng_pos          : stmt_type = key_implng
16550     = impboo_pos          : stmt_type = key_impboo
16560     = impchr_pos          : stmt_type = key_impchr
16570     = impvod_pos          : stmt_type = key_impvod
16580     = refnce_pos          : stmt_type = key_refnce : ref_ptr = 0
16590     END SELect
16600   POKE_W Mast_Addr(name_id), sec_wd-1 : REMark No. of calls to ROM routine
16610   END DEFine
16620 :
16630 DEFine PROCedure Store_Instance
16640   inst_ct = inst_ct + 1
16650   POKE_W bffr_last, fst_wd            : REMark line no
16660   POKE_W bffr_last+2, sec_wd          : REMark prior ptr
16670   POKE_W bffr_last+4, thd_wd          : REMark occurrence type
16680   POKE_W Mast_Addr(name_id), inst_ct : REMark hddr to new top of list
16690   bffr_last = bffr_last+child_size
16700   IF bffr_last > bffr_lim : quit = 1
16710   END DEFine
16720 :
16730 DEFine PROCedure Store_Trace_Instance
16740 LOCal ic, ptr
16750   ic = Item_Class((name_id))
16760   IF NOT (ic = class_usr_proc OR ic = class_usr_fn) : RETurn
16770   ic = 20 * ((thd_wd && defdef_val) = 0)
16780   Check_Page 1
16790   PRINT #chn;line_num;TO 6;FILL$(' ',ic);BASIC_NAME$(name_id);cr$
16800   IF ic = 0 : RETurn
16810   IF NOT scoping_procs : RETurn
16820   IF curproc=0
16830     ptr = Mast_Addr(name_id)
16840     POKE ptr+mst_hilev, 1 : POKE_W ptr+mst_scoptag, 0
16850     END IF
16860   IF curproc <> 0
16870     Store_Trace_Item curproc, name_id, mst_child
16880     Store_Trace_Item name_id, curproc, mst_parent
16890     END IF
16900   END DEFine
16910 :
16920 DEFine PROCedure Store_Trace_Item(curproc, name_id, offset)
16930   IF Proc_in_Trace(curproc, name_id, offset) : RETurn
16940   POKE_W trace_last, PEEK_W(Mast_Addr(curproc)+offset)
16950   POKE_W trace_last+2, name_id
16960   trace_ct = trace_ct + 1
16970   POKE_W Mast_Addr(curproc)+offset, trace_ct
16980   trace_last = trace_last + trace_child_sz
16990   IF trace_last > trace_lim : quit = 1
17000   END DEFine
17010 :

17020 DEFine PROCedure Modify_By_Ref_Params
17030 LOCal pass_lp, lp, hunt, ii
17040   IF ref_chain = 0 : RETurn
17050   ref_chain = Min_Int(ref_chain, max_refids)
17060   AT scan_line,25 : CLS 4
17070   src = BASIC_POINTER((bv_pfbas))+2
17080   REPeat pass_lp
17090     REPeat hunt
17100       Getsym
17110       IF Scan_Ended : EXIT pass_lp
17120       IF token=tok_name
17130         FOR ii=1 TO ref_chain : IF valu = ref_ids(ref_chain) : EXIT hunt
17140         ELSE
17150         Check_End_ProcFn
17160         END IF
17170       END REPeat hunt
17180     IF line_num <= 0 : NEXT pass_lp
17190     proc_id = valu

17200     IF stmt_type = key_define : NEXT pass_lp
17210     REMark ... so must be a 'call'
17220     mask_word = PEEK_W(Mast_Addr(proc_id)+mst_refparm)
17230     param_no = 0
17240     rtn_is_func = (class_usr_fn = Item_Class((proc_id)))
17250     IF rtn_is_func : Getsym : REMark Skip '(' for fn
17260     REPeat lp
17270       Getsym
17280       IF End_of_Stmt : EXIT lp
17290       IF token=tok_symbol AND valu=sym_clbrkt : NEXT lp
17300       IF token=tok_separator : NEXT lp
17310       param_no = param_no + 1
17320       IF token = tok_name

17330         name_id = valu : Skip_Subscr
17340         IF User_Defined(name_id)
17350           IF (mask_word && (2^(param_no-1))) <> 0
17360             Patch_Inst name_id, line_num : END IF : END IF
17370         END IF
17380       END REPeat lp
17390     END REPeat pass_lp
17400   Check_End_ProcFn
17410   END DEFine
17420 :
17430 DEFine PROCedure Patch_Inst(name_id, line_match)
17440 LOCal lp, fwd, a
17450   fwd = PEEK_W(Mast_Addr(name_id))
17460   REPeat lp
17470     IF fwd = 0 : EXIT lp
17480     a = Inst_Addr(fwd)
17490     line_num = PEEK_W(a)
17500     IF line_num = line_match
17510       IF PEEK_W(a+4) <> refass_val : POKE_W (a+4), refass_val : EXIT lp
17520       END IF
17530     fwd = PEEK_W(a+2)
17540     END REPeat lp
17550   END DEFine
17560 :
17570 DEFine FuNction Proc_in_Trace(curproc, name_id, offset)
17580 LOCal ptr, ii, lp
17590   ii = PEEK_W(Mast_Addr(curproc)+offset)
17600   REPeat lp
17610     IF ii = 0 : EXIT lp
17620     ptr = Trace_Next(ii)
17630     ii = PEEK_W(ptr) : IF PEEK_W(ptr+2) = name_id : RETurn 1
17640     END REPeat lp
17650   RETurn 0
17660   END DEFine
17670 :
17680 DEFine PROCedure Show_ProcTrace
17690 LOCal ptr, lp, moaner, ii, level, scope(50)
17700   AT scan_line,10 : PRINT "Tracing at level: "; : CLS 4
17710   ReBuild_Trace_Links
17720   line_ct = 0
17730   Check_Page 0
17740   PRINT #chn;\'Procedures aggregated by scope';\\'Level';TO 61;'Local space'\'0  > root module <';cr$
17750   line_ct = line_ct - 5
17760   IF debugging : PRINT #chn\\\ : Trace_Test chn : PRINT #chn
17770   level = 0 : tot_hits = 0
17780   REPeat lp
17790     level = level + 1 : AT scan_line,28 : PRINT level;
17800     Scan_Called_Lists level, 1
17810     max_level = level
17820     IF hits = 0 : EXIT lp
17830     tot_hits = tot_hits + hits
17840     END REPeat lp
17850   IF debugging : PRINT #chn\\\ : Trace_Test chn
17860   AT scan_line,10 : PRINT "Scoping at level: "; : CLS 4
17870   level = 0 : moaner = 1
17880   REPeat lp
17890     level = level + 1 : IF level > max_level : EXIT lp
17900     AT scan_line,28 : PRINT level;
17910     Scan_Called_Lists level, 0
17920     tot_hits = tot_hits - hits
17930     IF moaner
17940       IF tot_hits <> 0
17950         PRINT #chn;\\'The following routines reflect inelegant or bad structure'\\
17960         line_ct = line_ct - 3 : moaner = 0 : END IF : END IF
17970     END REPeat lp
17980   line_ct = 0
17990   END DEFine
18000 :
18010 DEFine PROCedure ReBuild_Trace_Links
18020 LOCal ii, lp, ptr
18030   ii = trace_proc_min - 1
18040   REPeat lp
18050     ii = ii + 1 : IF ii > trace_proc_max : EXIT lp
18060     IF PEEK(Mast_Addr(ii)+mst_procfn) <> 0 : Reverse_Trace (ii)
18070     END REPeat lp
18080   END DEFine
18090 :
18100 DEFine PROCedure Reverse_Trace (idx)
18110 LOCal lp, fwd, me_here, prior, ptr
18120   fwd = PEEK_W(Mast_Addr((idx))+mst_child)
18130   IF fwd <= 0 : RETurn
18140   me_here = fwd : fwd = 0
18150   REPeat lp
18160     ptr = Trace_Next((me_here))
18170     prior = PEEK_W(ptr)
18180     POKE_W ptr,fwd
18190     fwd = me_here
18200     IF prior = 0 : EXIT lp
18210     me_here = prior
18220     END REPeat lp
18230   POKE_W Mast_Addr((idx))+mst_child,fwd
18240   END DEFine
18250 :
18260 DEFine PROCedure Scan_Called_Lists(level, resolve)
18270 LOCal ii, jj, wanted, lp, ptr
18280   ii = trace_proc_min - 1 : hits = 0
18290   REPeat lp
18300     ii = ii + 1 : IF ii > trace_proc_max : EXIT lp
18310     ptr = Mast_Addr(ii)
18320     IF PEEK(ptr+mst_procfn) = 0 : NEXT lp
18330     jj = PEEK(ptr+mst_hilev)
18340     IF jj > 128
18350       jj = jj - 128 : POKE ptr+mst_hilev, jj
18360       wanted = (jj <= level)
18370       ELSE
18380       wanted = (jj = level) : END IF
18390     IF wanted
18400       IF resolve
18410         IF jj = 1 : hits = hits + 1
18420         Build_Scoping_History ii, scope, level-1
18430         scope(level) = ii
18440         Resolve_Trace_List ii, level+1
18450         ELSE
18460         cum_local = 0
18470         Print_Proc_Trace ii, level : END IF
18480       END IF
18490     END REPeat lp
18500   END DEFine
18510 :
18520 DEFine PROCedure Resolve_Trace_List(caller, level)
18530 LOCal lp, ptr, instance, called
18540 :
18550   REMark For each instance of a routine called by 'caller',
18560   REMark assign the scoping tag/level, the high tag/level and
18570   REMark the low tag/level.  Self recursive calls are not pursued.
18580   REMark Indirect recursive calls are not pursued.
18590   REMark Scoping tag/level is set for first reference to a routine;
18600   REMark - otherwise call sequence comparisons are made to establish
18610   REMark   the scoping tag/level.
18620   REMark High tag is always set. High level is set if appropriate.
18630   REMark Low tag/level are set if appropriate.
18640 :
18650   instance = PEEK_W(Mast_Addr(caller)+mst_child)
18660   REPeat lp
18670     IF instance = 0 : EXIT lp
18680     ptr = Trace_Next(instance)
18690     instance = PEEK_W(ptr)
18700     called   = PEEK_W(ptr+2)
18710     ptr = Mast_Addr(called)
18720     IF PEEK(ptr+mst_recur) = 2 : NEXT lp : REMark Indirect recursion
18730     IF called = caller : POKE ptr+mst_recur,1 : NEXT lp
18740     IF PEEK_W(ptr+mst_scoptag) = -1
18750                       REMark First time that routine has been called
18760       POKE_W ptr+mst_scoptag, caller
18770       POKE   ptr+mst_scoplev, level
18780       hits = hits + 1
18790       ELSE
18800       IF Scoping_Problem(called,level) : NEXT lp
18810       END IF
18820     IF level > PEEK(ptr+mst_hilev) : POKE ptr+mst_hilev, level
18830     POKE_W ptr+mst_hitag, caller
18840     IF level < PEEK(ptr+mst_lolev)
18850       POKE ptr+mst_lolev, level : POKE_W ptr+mst_lotag, caller : END IF
18860     END REPeat lp
18870   END DEFine
18880 :
18890 DEFine FuNction Scoping_Problem(called,level)
18900 LOCal ptr, ii, jj, called_scope(50)
18910 :
18920 REMark The 'called' routine which is called by 'caller' has also
18930 REMark been called from another flow path, so find the (hierarchically)
18940 REMark lowest level to which the routine can be considered "LOCal"
18950 :
18960   ptr = Mast_Addr(called)
18970   IF PEEK_W(ptr+mst_scoptag) = 0
18980             REMark Already at top scoping level
18990     IF PEEK_W(ptr+mst_child) = 0 : RETurn 0
19000             REMark - and no children, so no recursion possible
19010     END IF
19020   IF Routine_in_Call_Paths(called, called, level-1) : RETurn 1
19030   IF PEEK_W(ptr+mst_scoptag) = 0 : RETurn 0
19040                                  REMark Already at top scoping level
19050   Build_Scoping_History called, called_scope, level
19060   jj = PEEK(ptr+mst_scoplev)
19070   FOR ii = 1 TO jj : IF scope(ii) <> called_scope(ii) : EXIT ii
19080   IF ii < jj
19090     POKE   ptr+mst_scoplev, ii
19100     POKE_W ptr+mst_scoptag, scope(ii-1)
19110     END IF
19120   RETurn 0
19130   END DEFine
19140 :
19150 DEFine FuNction Routine_in_Call_Paths(look_at, called,level)
19160 LOCal ptr, lp, parent, instance
19170 :
19180   REMark Follow all permutations of call path that can lead to the
19190   REMark routine 'look_at', searching for any call path that involves
19200   REMark the routine 'called'.  If found, the call sequence is
19210   REMark indirectly recursive on 'called'.
19220 :
19230   IF level < 1 : RETurn 0
19240   IF debugging<0 : PRINT #chn;'Called: ';called;'  scan: ';look_at;'  level: ';level
19250   ptr = Mast_Addr(look_at)
19260   instance = PEEK_W(ptr+mst_parent)
19270   REPeat lp
19280     IF instance = 0 : EXIT lp
19290     ptr = Trace_Next(instance)
19300     instance = PEEK_W(ptr)
19310     parent   = PEEK_W(ptr+2)
19320     IF parent = called
19330       Force_Scoping_Level called, caller, level
19340       RETurn 1 : END IF
19350     IF Routine_in_Call_Paths(parent, called, level-1) : RETurn 1
19360     END REPeat lp
19370   RETurn 0
19380   END DEFine
19390 :
19400 DEFine PROCedure Force_Scoping_Level(called, caller, level)
19410 LOCal ptr
19420   ptr = Mast_Addr(called)
19430   REMark Dubious use of recursion in target program - force to highest level
19440   POKE   ptr+mst_hilev, 128+level
19450   POKE_W ptr+mst_hitag, PEEK_W(ptr+mst_scoptag)
19460   POKE_W ptr+mst_lotag, caller
19470   POKE   ptr+mst_recur, 2
19480   END DEFine
19490 :
19500 REFERENCE array(0)
19510 DEFine PROCedure Build_Scoping_History(called, array, level)
19520 LOCal lp, ii, jj
19530 :
19540   REMark Backtrack the call sequence, creating in 'array' the
19550   REMark nametags of the calling routines that denote the 'scope' -
19560   REMark set in the array at the appropriate index point for the
19570   REMark scoping level.  Gaps are filled in at the higher nametag.
19580 :
19590   FOR ii = 0 TO level : array(ii) = 0
19600   jj = called
19610   REPeat lp
19620     jj = PEEK_W(Mast_Addr(jj)+mst_scoptag) : IF jj <= 0 : EXIT lp
19630     ii = PEEK(Mast_Addr(jj)+mst_scoplev)
19640     array(ii) = jj
19650     END REPeat lp
19660   FOR ii = 1 TO level : IF array(ii) = 0 : array(ii) = array(ii-1)
19670   END DEFine
19680 :
19690 DEFine PROCedure Print_Proc_Trace(caller, level)
19700 LOCal lp, localsp, instance, called, ptr, ptr1, jj, kk, a$(2), b$(120)
19710   Check_Page 1
19720   ptr = Mast_Addr(caller) : b$ = ""
19730   localsp = PEEK_L(ptr+mst_datasz)
19740   kk = Max_Int(PEEK(ptr+mst_scoplev), level)
19750   IF localsp <> 0
19760     jj = Max_Int(1, 66- 4*kk -LEN(BASIC_NAME$(caller))-LEN(localsp))
19770     b$ = FILL$(' ',jj) & localsp
19780     cum_local = cum_local + localsp + call_size
19790     IF cum_local > max_local_data : max_local_data = cum_local
19800     END IF
19810   IF PEEK(ptr+mst_recur) <> 0
19820     IF PEEK(ptr+mst_recur) = 2
19830       b$ = b$ & cr$ & CHR$(10) & "   (Indirect recursion from '" & BASIC_NAME$(PEEK_W(ptr+mst_lotag)) & "')"
19840       line_ct = line_ct - 1
19850       ELSE
19860       jj = Max_Int(0, 66- 4*kk -LEN(BASIC_NAME$(caller))-LEN(b$))
19870       b$ = b$ & FILL$(' ',jj) & " (recursive)" : END IF
19880     IF localsp > local_recur : local_recur = localsp
19890     END IF
19900   kk = PEEK(ptr+mst_scoplev)
19910   IF kk <> level : a$="*" : ELSE : a$="" : kk = 0
19920   PRINT #chn; level;TO 4+4*kk;a$;TO 4+4*level; BASIC_NAME$(caller);b$; cr$
19930   POKE ptr+mst_hilev, 0 : ptr = ptr + mst_child
19940   REPeat lp
19950     instance = PEEK_W(ptr) : IF instance = 0 : EXIT lp
19960     ptr = Trace_Next(instance)
19970     called = PEEK_W(ptr+2) : IF called = caller : NEXT lp
19980     ptr1 = Mast_Addr(called)
19990     IF PEEK(ptr1+mst_hilev) = 0 : NEXT lp
20000     IF PEEK_W(ptr1+mst_hitag)=caller
20010       Print_Proc_Trace called, PEEK(ptr1+mst_hilev) : END IF
20020     END REPeat lp
20030   cum_local = cum_local - localsp - call_size
20040   hits = hits + 1
20050   END DEFine
20060 :
20070 DEFine PROCedure Show_Stats(chn)
20080 LOCal cr$(2)
20090   IF chn <> 1
20100     line_ct = line_ct - 4 : cr$ = CHR$(13)
20110     ELSE : cr$ = "" : END IF
20120   PRINT #chn;\"Stats:   Total names  User names  Occurrences  Buffer size  Trace buffer";cr$
20130   PRINT #chn,TO 12;max_names;TO 25;act_names;TO 37;inst_ct;TO 49;(bffr_last - bffr);TO 62;(trace_last-trace_base)\;cr$
20140   END DEFine
20150 :
20160 DEFine PROCedure Print_Panel(printing_ROMs)
20170 LOCal ii
20180   names_shown = 0
20190   FOR ii = 0 TO max_names-1 : Print_Details (ii)
20200   END DEFine
20210 :
20220 DEFine PROCedure Print_Details (idx)
20230   nt_indx = PEEK_W(Mast_Addr((idx))+mst_nti)
20240   IF NOT (User_Defined((nt_indx)) - printing_ROMs) : RETurn
20250   IF main_report : Reverse_Links (idx) : ELSE : fwd = PEEK_W(Mast_Addr((idx)))
20260   IF fwd = 0 : RETurn
20270   names_shown = 1
20280   pending = 1 : defined = 0 : referred = 0 : valued = 0
20290   REPeat walk_fwd
20300     IF NOT printing_ROMs : Get_Instance (fwd)
20310     IF pending : Print_Name (idx)
20320     IF printing_ROMs : EXIT walk_fwd
20330     Print_Instance
20340     IF fwd = 0 : EXIT walk_fwd
20350     END REPeat walk_fwd
20360   IF NOT silent : PRINT #chn;cr$
20370   IF Data_Item(nt_indx)
20380     dval = PEEK_L(Mast_Addr(idx)+mst_datasz)
20390     IF PEEK(Mast_Addr(idx)+mst_btyp) = type_man : dval = 0
20400     data_size = data_size + add_size + dval
20410     IF referred AND valued : POKE_W Mast_Addr((idx)),0
20420     ELSE
20430     IF defined = 1 AND referred : POKE_W Mast_Addr((idx)),0
20440     END IF
20450   END DEFine
20460 :
20470 DEFine PROCedure Reverse_Links (idx)
20480   fwd = PEEK_W(Mast_Addr((idx)))
20490   IF fwd <= 0 : RETurn
20500   me_here = fwd : fwd = 0
20510   REPeat back_scan
20520     prior = PEEK_W(Inst_Addr((me_here))+2)
20530     POKE_W Inst_Addr((me_here))+2,fwd
20540     fwd = me_here
20550     IF prior = 0 : EXIT back_scan
20560     me_here = prior
20570     END REPeat back_scan
20580   POKE_W Mast_Addr((idx)),fwd
20590   END DEFine
20600 :
20610 DEFine PROCedure Get_Instance(xx)
20620   line_num = PEEK_W(Inst_Addr((xx)))
20630   fwd = PEEK_W(Inst_Addr((xx))+2)
20640   flag = PEEK_W(Inst_Addr((xx))+4)
20650   END DEFine
20660 :
20670 DEFine PROCedure Print_Name (idx)
20680   nt_indx = PEEK_W(Mast_Addr((idx))+mst_nti)
20690   ic = Item_Class((nt_indx))
20700   SELect ON ic
20710     = class_usr_array                : q$ = "A " & Data_Type$(idx)
20720     = class_usr_proc, class_ROM_proc : q$ = "P   " : add_size = 0
20730     = class_usr_fn, class_ROM_fn     : q$ = "F " & Data_Type$(idx)
20740     = REMAINDER                      : q$ = "  " & Data_Type$(idx)
20750     END SELect
20760   IF silent : RETurn
20770   Check_Page 1
20780   PRINT #chn;q$;BASIC_NAME$((nt_indx));
20790   line_ptr = Max_Int((5+stepper*((LEN((BASIC_NAME$((nt_indx))))+stepper-1) DIV stepper)),19)
20800   IF printing_ROMs : PRINT #chn;TO line_ptr;ABS((PEEK_W((Mast_Addr((idx))))));
20810   pending = 0
20820   END DEFine
20830 :
20840 DEFine FuNction Data_Type$(idx)
20850   bt = PEEK(Mast_Addr((idx))+mst_btyp)
20860   SELect ON bt
20870     = type_str       : add_size = 3 : RETurn "S "
20880     = type_int       : add_size = 2 : RETurn "I "
20890     = type_dbl       : add_size = 6 : RETurn "D "
20900     = type_boo       : add_size = 6 : RETurn "B "
20910     = type_chr       : add_size = 3 : RETurn "C "
20920     = type_flt       : add_size = 6 : RETurn "F "
20930     = type_lng       : add_size = 6 : RETurn "L "
20940     = type_void      : add_size = 0 : RETurn "V "
20950     = type_man       : add_size = 0 : RETurn "M "
20960     = REMAINDER      : add_size = 6 : RETurn "  "
20970     END SELect
20980   END DEFine
20990 :
21000 DEFine PROCedure Print_Instance
21010   IF line_ptr > max_width AND NOT silent
21020      PRINT #chn;cr$ : line_ptr = 5+stepper+stepper
21030      Check_Page 1
21040      END IF
21050   SELect ON flag
21060     =defuse_val : q$ = "L"  : valued = 1 : defined = 1  : add_size = 0
21070     =locdef_val : q$ = "L"               : defined = 1  : add_size = 0
21080     =repvar_val : q$ = "r"  : valued = 1 : referred = 1
21090     =assign_val : q$ = "a"  : valued = 1
21100     =forvar_val : q$ = "f"  : valued = 1 : referred = 1
21110     =defdef_val,dimdef_val  : q$ = "d"   : defined = defined + 1
21120     =refnce_val : q$ = "R"  : referred = 1
21130     =refass_val : q$ = "A"  : valued = 1 : referred = 1
21140     =REMAINDER              : q$ = ""    : referred = 1
21150     END SELect
21160   IF NOT silent
21170     PRINT #chn; TO (line_ptr+5 - LEN(line_num));line_num;q$;
21180     line_ptr = line_ptr + stepper : END IF
21190   END DEFine
21200 :
21210 DEFine PROCedure Prompt(col,cr$)
21220   INK 4 : IF col<>0 : PRINT TO col;
21230   PRINT cr$; : INK 7 : INPUT q$
21240   END DEFine
21250 :
21260 DEFine PROCedure Check_Page(lins)
21270 LOCal q$(30)
21280   line_ct = line_ct - lins
21290   IF line_ct >= 1 : RETurn
21300   IF page > 0 : PRINT #chn;tof$; : ELSE : PRINT #chn;cr$;
21310   IF cut_sheet : AT scan_line+7,0 : Prompt 10,'Press ENTER to continue printing' : CLS 3
21320   page = page + 1 : q$ = DATE$ : q$ = q$(1 TO 17)
21330   PRINT #chn,"PDQ XREF v";vers$;" - SuperBASIC Cross Reference List   Page: ";page; TO 61;q$;cr$
21340   PRINT #chn;TO 18;'Program: ';pnam$;\cr$
21350   line_ct = lpp-9-lins
21360   END DEFine
21370 :
21380 DEFine FuNction Mast_Addr(x)
21390   RETurn PEEK_L(bffr+x*4)
21400   END DEFine
21410 :
21420 DEFine FuNction Inst_Addr(x)
21430   RETurn bffr_base+x*child_size
21440   END DEFine
21450 :
21460 DEFine FuNction Head_Ptr(xx)
21470   RETurn PEEK_W(Mast_Addr((xx)))
21480   END DEFine
21490 :
21500 DEFine FuNction Trace_Next(idx)
21510   RETurn trace_ch_base + idx * trace_child_sz
21520   END DEFine
21530 :
21540 DEFine FuNction User_Defined(xx)
21550   RETurn Item_Class((xx)) < 8
21560   END DEFine
21570 :
21580 DEFine FuNction Data_Item(name_id)
21590   ic = Item_Class((name_id))
21600   SELect ON ic
21610     = class_usr_proc, class_usr_fn, class_ROM_proc, class_ROM_fn
21620             RETurn 0
21630     END SELect
21640   RETurn 1
21650   END DEFine
21660 :
21670 DEFine FuNction Item_Class(xx)
21680   RETurn BASIC_B%((BASIC_L((bv_ntbas))) + xx * nt_entry)
21690   END DEFine
21700 :
21710 DEFine FuNction Max_Int(xx,yy)
21720   IF xx > yy : RETurn xx : ELSE : RETurn yy
21730   END DEFine
21740 :
21750 DEFine FuNction Min_Int(xx,yy)
21760   IF xx < yy : RETurn xx : ELSE : RETurn yy
21770   END DEFine
21780 :
21790 DEFine FuNction Assignment
21800   SELect ON stmt_type
21810     = key_manfst     : RETurn 1
21820     = key_let, key_for, 0 : RETurn Next_is_Equals
21830     = read_or_input  : IF hash_was_last : hash_was_last = 0 : RETurn 0
21840                        RETurn NOT brkct
21850     END SELect
21860   RETurn 0
21870   END DEFine
21880 :
21890 DEFine FuNction Next_is_Equals
21900 LOCal lp, tmpass
21910   IF assigned : RETurn 0
21920   Look_Ahead
21930   IF Symbol_is_Assign : Confirm_Look : assigned=1 : RETurn 1
21940   IF NOT brkct : BackTrack : RETurn 0
21950   REPeat lp
21960     Getsym : IF End_of_Stmt : EXIT lp
21970     IF NOT brkct : Getsym : EXIT lp
21980     END REPeat lp
21990   tmpass = Symbol_is_Assign
22000   BackTrack
22010   IF tmpass : assigned = 1
22020   RETurn assigned
22030   END DEFine
22040 :
22050 DEFine PROCedure Look_Ahead
22060   keep_ptr    = src
22070   keep_stmt   = stmt_type
22080   keep_assign = assigned
22090   keep_hash   = hash_was_last
22100   keep_brkct  = brkct
22110   keep_param  = param_no
22120   keep_valu   = valu
22130   scanning = 1
22140   Getsym
22150   END DEFine
22160 :
22170 DEFine PROCedure BackTrack
22180   src           = keep_ptr
22190   stmt_type     = keep_stmt
22200   assigned      = keep_assign
22210   hash_was_last = keep_hash
22220   brkct         = keep_brkct
22230   param_no      = keep_param
22240   valu          = keep_valu
22250   scanning = 0
22260   END DEFine
22270 :
22280 DEFine PROCedure Confirm_Look
22290   target = src
22300   BackTrack
22310   REPeat lp : Getsym : IF src >= target : EXIT lp
22320   END DEFine
22330 :
22340 DEFine FuNction Decoded_Size(name_id)
22350 LOCal lp, occurs, brkt, valid, binthere
22360   Look_Ahead
22370   IF NOT Open_Brkt : BackTrack : RETurn 0
22380   valid = 1 : occurs = 1 : brkt = 1 : binthere = 0
22390   REPeat lp
22400     Getsym
22410     SELect ON token
22420       = tok_nomin TO tok_nomax
22430              occurs = occurs * (numval + 1) : binthere = 1
22440       = tok_symbol
22450              SELect ON symval
22460                = sym_opbrkt : brkt = brkt + 1 : NEXT lp
22470                = sym_comma  : IF brkt : NEXT lp : ELSE : EXIT lp
22480                = sym_clbrkt : brkt = brkt - 1 : IF NOT brkt : EXIT lp
22490                = sym_eol    : EXIT lp
22500                END SELect
22510              valid = 0 : EXIT lp
22520       = tok_name : IF PEEK(Mast_Addr(valu)+mst_btyp) <> type_man
22530                      valid = 0 : EXIT lp : END IF
22540                    numval = PEEK_L(Mast_Addr(valu)+mst_datasz)
22550                    IF numval <= 0 : valid = 0 : EXIT lp
22560                    occurs = occurs * (numval + 1) : binthere = 1
22570       =REMAINDER : valid = 0 : EXIT lp
22580       END SELect
22590     END REPeat lp
22600   BackTrack
22610   IF NOT valid : RETurn 0
22620   valid = Size_Factor(name_id)
22630   IF valid = 1 AND NOT binthere : RETurn avg_str_len
22640   RETurn occurs * valid
22650   END DEFine
22660 :

22670 DEFine PROCedure Skip_Subscr
22680 LOCal lp, brkt
22690   Look_Ahead
22700   IF NOT Open_Brkt : BackTrack : RETurn
22710   brkt = 1
22720   REPeat lp
22730     Getsym
22740     SELect ON token
22750       = tok_symbol
22760              SELect ON symval
22770                = sym_opbrkt : brkt = brkt + 1
22780                = sym_comma  : IF brkt <= 0 : EXIT lp
22790                = sym_clbrkt : brkt = Max_Int(0, brkt - 1)
22800                = sym_colon  : src=src-2 : EXIT lp
22810                = sym_eol    : src=src-2 : EXIT lp
22820                END SELect
22830       =REMAINDER : IF brkt = 0 : EXIT lp
22840       END SELect
22850     END REPeat lp
22860   Confirm_Look
22870   END DEFine
22880 :
22890 DEFine FuNction Size_Factor(name_id)
22900 LOCal data_type
22910   data_type = PEEK(Mast_Addr(name_id)+mst_btyp)
22920   SELect ON data_type
22930     = type_str    : RETurn 1
22940     = type_int    : RETurn 2
22950     = REMAINDER   : RETurn 6
22960     END SELect
22970   END DEFine
22980 :
22990 DEFine PROCedure Getsym
23000   end_def = 0
23010   Skip_Spaces
23020   SELect ON token
23030     =tok_keyword
23040             valu=PEEK(src+1) : src=src+2
23050             SELect ON valu
23060               = key_then    : Clear_Stmt
23070               = key_mistake : IF NOT scanning
23080                                 IF chn <> 1 : PRINT #chn;'MISTake at line ';line_num;cr$
23090                                 AT scan_line+3,0 : PRINT 'MISTake at line ';line_num
23100                                 BEEP 10000,25000,1,100,1000,100
23110                                 END IF
23120               = key_define  : src=src+2
23130               = key_end     : src=src+2
23140                               IF PEEK(src-1)=key_define
23150                                 end_def = 1
23160                                 IF PEEK(src) = tok_name : src=src+4
23170                                 REMark discard END DEFine name
23180                                 END IF
23190               END SELect
23200             IF stmt_type = 0 AND brkct = 0

23210               IF valu <> key_then : stmt_type = valu : assigned = 0
23220               END IF
23230     =tok_symbol
23240             valu=PEEK(src+1) : src=src+2 : symval = valu
23250             SELect ON symval
23260               = sym_hash   : hash_was_last = 1
23270               = sym_opbrkt : brkct = brkct + 1
23280               = sym_clbrkt : brkct = brkct - 1 : hash_was_last = 0
23290               = sym_colon  : IF stmt_type <> key_manfst : Clear_Stmt
23300               = sym_eol    : src=src+2
23310                              IF src>BASIC_POINTER((bv_pfp))
23320                                token=tok_end_of_prog : src=src-4 : END IF
23330                              Clear_Stmt
23340               = REMAINDER  : hash_was_last = 0
23350               END SELect
23360     =tok_name               : valu=PEEK_W(src+2) : src=src+4
23370     =tok_nomin TO tok_nomax : numval = PEEK_F(src) : src=src+6
23380     =tok_lineno             : line_num=PEEK_W(src+2) : src=src+4
23390                               IF NOT scanning : AT scan_line,25 : PRINT line_num;
23400     =tok_strng,tok_text     : lval=src+2
23410                               src=4+PEEK_W(lval)+(PEEK_W(lval) MOD 2)+src
23420     =REMAINDER              : src=src+2 : hash_was_last = 0
23430     END SELect
23440   END DEFine
23450 :
23460 DEFine PROCedure Clear_Stmt
23470   param_no = 0

23480   stmt_type = 0 : assigned = 0
23490   hash_was_last = 0 : brkct = 0
23500   END DEFine
23510 :
23520 DEFine PROCedure Skip_Spaces
23530 LOCal lp
23540   REPeat lp
23550     token=PEEK(src)
23560     IF token<>tok_space : EXIT lp
23570     src=src+2
23580     END REPeat lp
23590   END DEFine
23600 :
23610 DEFine FuNction Symbol_is_Assign
23620   RETurn (token=tok_symbol AND valu=sym_assign)
23630   END DEFine
23640 :
23650 DEFine FuNction Open_Brkt
23660   RETurn (token=tok_symbol AND valu=sym_opbrkt)
23670   END DEFine
23680 :
23690 DEFine FuNction End_of_Stmt
23700   RETurn (token=tok_symbol AND (valu=sym_colon OR valu=sym_eol)) OR token=tok_end_of_prog
23710   END DEFine
23720 :
23730 DEFine PROCedure Sort_Names(listlim)
23740 LOCal x, y
23750   Sort_Quick 1, listlim, 0
23760   END DEFine
23770 :
23780 DEFine PROCedure Sort_Quick(btm, top, lev)
23790 LOCal loop, lo, hi, ptr
23800   AT scan_line+6,Colm(lev) : PRINT top-btm+1; : CLS 4
23810   lo = btm : hi = top : ptr = btm
23820   REPeat loop
23830     IF lo >= hi : EXIT loop
23840     x = Mast_Addr((lo-1)) : y = Mast_Addr((hi-1))
23850     IF BASIC_NAME$((PEEK_W((x+mst_nti)))) > BASIC_NAME$((PEEK_W((y+mst_nti))))
23860 :
23870       POKE_L (bffr_base),      (x)    : REMark Swap pointers to names
23880       POKE_L (bffr+(lo-1)*4),  (y)
23890       POKE_L (bffr+(hi-1)*4),  PEEK_L((bffr_base))
23900 :
23910       IF ptr = lo
23920         lo = lo+1 : ptr = hi
23930         ELSE
23940         hi = hi-1 : ptr = lo : END IF
23950       ELSE
23960       IF ptr = lo
23970         hi = hi-1 : ELSE lo = lo+1 : END IF
23980       END IF
23990     END REPeat loop
24000   IF ABS(top-btm) >= 2
24010     lo = ptr-btm
24020     hi = top-ptr
24030     IF lo < hi
24040       IF lo > 0 : Sort_Quick btm, ptr-1, lev+1
24050       IF hi > 0 : Sort_Quick ptr+1, top, lev+1
24060       ELSE
24070       IF hi > 0 : Sort_Quick ptr+1, top, lev+1
24080       IF lo > 0 : Sort_Quick btm, ptr-1, lev+1
24090       END IF : END IF
24100   AT scan_line+6,Colm(lev) : CLS 4
24110   END DEFine
24120 :
24130 DEFine FuNction Colm(lev)
24140 LOCal ii
24150   ii = 15 + lev * 4
24160   IF ii <= win_widf : RETurn ii
24170   RETurn win_widf
24180   END DEFine
24190 :
24200 DEFine PROCedure Trace_Test(chn)
24210 LOCal ii, ptr
24220   PRINT #chn
24230   FOR ii=trace_proc_min TO trace_proc_max
24240     ptr = Mast_Addr(ii)
24250     IF PEEK(ptr+mst_procfn) = 0 : NEXT ii : EXIT ii
24260     PRINT #chn,BASIC_NAME$(ii);TO 30;ii;TO 35;PEEK(ptr+mst_hilev);TO 39;PEEK(ptr+mst_lolev);TO 43;PEEK(ptr+mst_scoplev);
24270     PRINT #chn,TO 48;PEEK_W(ptr+mst_hitag);TO 53;PEEK_W(ptr+mst_lotag);TO 58;PEEK_W(ptr+mst_scoptag);TO 63;PEEK(ptr+mst_recur)
24280     Trace_List PEEK_W(ptr+mst_child)
24290     Trace_List PEEK_W(ptr+mst_parent)
24300     END FOR ii
24310   PRINT #chn
24320   END DEFine
24330 :
24340 DEFine PROCedure Trace_List(base)
24350 LOCal kk, ptr1, lp
24360   kk = base
24370   REPeat lp
24380     IF kk = 0 : EXIT lp
24390     ptr1 = Trace_Next(kk)
24400     kk = PEEK_W(ptr1)
24410     PRINT #chn;PEEK_W(ptr1+2);'   ';
24420     END REPeat lp
24430   PRINT #chn
24440   END DEFine
